<template>
  <q-page class="q-pa-sm">
    <div class="q-pa-sm">
      <div class="text-h4">{{ store.item.title }}</div>
    </div>
    <div class="q-pa-sm">
      <span class="text-grey">By </span> <b>{{ store.item.author }}</b> |
      {{ store.item.created_at }}
    </div>
    <div class="q-pa-sm">
      <image-view
        :src="store.item.thumbnail"
        :alt="placeholderImages.game"
        :ratio="2"
      />
    </div>
    <div class="text-grey q-pa-sm" v-html="store.item.content"></div>
    <div class="q-pa-sm">
      <div class="text-h6 text-bold q-pa-sm">Game Info</div>
      <q-card flat bordered style="font-family: monospace">
        <q-card-section class="text-center text-grey">
          <div>Deskripsi :</div>
          <div>
            {{ store.item.description }}
          </div>
        </q-card-section>
      </q-card>
      <div class="row q-pa-sm">
        <div class="col-md-2 col-xs-12 text-orange"><b>Game</b></div>
        <div class="col-md-10 col-xs-12">{{ store.item.title }}</div>
      </div>
      <div class="row q-pa-sm">
        <div class="col-md-2 col-xs-12 text-orange"><b>Genre</b></div>
        <div class="col-md-10 col-xs-12">
          {{ store.item.genre.toUpperCase() }}
        </div>
      </div>
      <div class="row q-pa-sm">
        <div class="col-md-2 col-xs-12 text-orange"><b>Device</b></div>
        <div class="col-md-10 col-xs-12">
          {{ ['Android', 'PC'].map((d) => d.toUpperCase()).join(' & ') }}
        </div>
      </div>
    </div>
  </q-page>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import { useInfoGameStore } from 'stores/info-game';
import { placeholderImages } from 'src/boot/placeholder';
import ImageView from 'src/components/ImageView.vue';

export default defineComponent({
  name: 'GameInfoPage',

  components: {
    ImageView,
  },
  setup() {
    const store = useInfoGameStore();
    return { store, placeholderImages };
  },
  async beforeRouteEnter(
    to: unknown,
    _prev: unknown,
    next: (r?: string) => unknown
  ) {
    try {
      const blogs = useInfoGameStore();
      const { slug } = (to as { params: { slug: string } }).params;
      await blogs.fetchItem(slug);
      next();
    } catch (err) {
      next('/not-found');
    }
  },
  async beforeRouteUpdate(
    to: unknown,
    _prev: unknown,
    next: (r?: string) => unknown
  ) {
    try {
      const blogs = useInfoGameStore();
      const { slug } = (to as { params: { slug: string } }).params;
      await blogs.fetchItem(slug);
      next();
    } catch (err) {
      next('/not-found');
    }
  },
});
</script>
